{{

        RIC_7SegmentLED.spin
        7 Segment LED control code for propeller chip with:
                1x 74HCT595 chip for serial to parallel conversion
                1x Radio Shack 7 Segment LED

}}

CON
  ' %00000010 : TOP LED
  ' %00000100 : RTOP LED
  ' %00001000 : RBOT LED
  ' %00010000 : BOT LED
  ' %00100000 : LBOT LED
  ' %01000000 : LTOP LED
  ' %10000000 : MID LED
  'Constants for display of different numeric values
  DISP_1 = %00001100
  DISP_2 = %10110110
  DISP_3 = %10011110
  DISP_4 = %11001100
  DISP_5 = %11011010
  DISP_6 = %11111010
  DISP_7 = %00001110
  DISP_8 = %11111110
  DISP_9 = %11011110
  DISP_0 = %01111110


VAR
  long                PIN_DATA, PIN_CLOCK, PIN_LATCH          
  byte                bytePattern
  
OBJ
  IO            : "ShiftIO"
  TIME          : "Timing"

PUB Initialize (pinData, pinClock, pinLatch)
{{
    Initializes the object and stores the pins for data, clock and latch locally
}}

  'Capture the pins for this instance
  PIN_DATA := pinData
  PIN_CLOCK := pinClock
  PIN_LATCH := pinLatch

  
PUB SetValue (lNumber)
{{
    Code needs to be updates to check for a launched cog and then launch the func in a new cog
}}

  SetValueFunc (lNumber)
  


PRI SetValueFunc (lNumber)
{{
}}

  'Init the byte pattern to null
  bytePattern := %00000000
  
  'Figure out what pattern to use
  case lNumber
    1: bytePattern := DISP_1
    2: bytePattern := DISP_2
    3: bytePattern := DISP_3
    4: bytePattern := DISP_4
    5: bytePattern := DISP_5
    6: bytePattern := DISP_6
    7: bytePattern := DISP_7
    8: bytePattern := DISP_8
    9: bytePattern := DISP_9
    0: bytePattern := DISP_0

  'Set the pins to output and put low
  dira [PIN_LATCH] := 1
  outa [PIN_LATCH] := 0

  'Shift out the data
  IO.shiftout (PIN_DATA, PIN_CLOCK, IO#MsbFirst, bytePattern, 8)
  'Latch the data, pause, unlatch
  outa [PIN_LATCH] := 1
  TIME.pause10us (11)
  outa [PIN_LATCH] := 0